#!/bin/bash

# This test file must be ran by util/test-bash-functions.

TESTS=1

cat <<EOF > $TMPDIR/expected
  #ts device          rd_s rd_avkb rd_mb_s rd_mrg rd_cnc   rd_rt    wr_s wr_avkb wr_mb_s wr_mrg wr_cnc   wr_rt busy in_prg
  2.0 ram0             0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  2.0 cciss/c0d0       0.0     0.0     0.0     0%    0.0     0.0    23.0    53.2     0.6    85%    0.0     0.9   0%      0
  2.0 cciss/c0d0p1     0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  2.0 cciss/c0d0p2     0.0     0.0     0.0     0%    0.0     0.0    23.0    53.2     0.6    85%    0.0     0.9   0%      0
  2.0 cciss/c0d1     466.5    44.6    10.2     0%   11.2    23.9   985.0    47.5    22.8     0%    0.1     0.1  92%     18
  2.0 cciss/c1d0       0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  2.0 dm-0             0.0     0.0     0.0     0%    0.0     0.0   153.0     8.0     0.6     0%    0.1     0.8   0%      0
  2.0 md0              0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  #ts device          rd_s rd_avkb rd_mb_s rd_mrg rd_cnc   rd_rt    wr_s wr_avkb wr_mb_s wr_mrg wr_cnc   wr_rt busy in_prg
  4.0 ram0             0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  4.0 cciss/c0d0       0.0     0.0     0.0     0%    0.0     0.0    16.0    35.5     0.3    77%    0.0     0.4   0%      0
  4.0 cciss/c0d0p1     0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  4.0 cciss/c0d0p2     0.0     0.0     0.0     0%    0.0     0.0    16.0    35.5     0.3    77%    0.0     0.4   0%      0
  4.0 cciss/c0d1     373.0    47.2     8.6     0%   10.2    27.4   560.0    46.2    12.6     0%    0.1     0.1  91%     17
  4.0 cciss/c1d0       0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  4.0 dm-0             0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  4.0 md0              0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  #ts device          rd_s rd_avkb rd_mb_s rd_mrg rd_cnc   rd_rt    wr_s wr_avkb wr_mb_s wr_mrg wr_cnc   wr_rt busy in_prg
  5.0 ram0             0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  5.0 cciss/c0d0       0.0     0.0     0.0     0%    0.0     0.0     4.0    62.0     0.1    87%    0.0     0.0   0%      0
  5.0 cciss/c0d0p1     0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  5.0 cciss/c0d0p2     0.0     0.0     0.0     0%    0.0     0.0     4.0    62.0     0.1    87%    0.0     0.0   0%      0
  5.0 cciss/c0d1     848.0    42.6    17.7     0%   21.6    25.5  1979.0    49.7    48.0     0%    0.2     0.1 178%      9
  5.0 cciss/c1d0       0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  5.0 dm-0             0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  5.0 md0              0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  #ts device          rd_s rd_avkb rd_mb_s rd_mrg rd_cnc   rd_rt    wr_s wr_avkb wr_mb_s wr_mrg wr_cnc   wr_rt busy in_prg
  7.0 ram0             0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  7.0 cciss/c0d0       0.0     0.0     0.0     0%    0.0     0.0    21.0    74.7     0.8    89%    0.0     0.5   0%      0
  7.0 cciss/c0d0p1     0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  7.0 cciss/c0d0p2     0.0     0.0     0.0     0%    0.0     0.0    21.0    74.7     0.8    89%    0.0     0.5   0%      0
  7.0 cciss/c0d1     340.0    36.6     6.1     0%    8.1    23.8   913.0    49.4    22.0     0%    0.1     0.1  86%      5
  7.0 cciss/c1d0       0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
  7.0 dm-0             0.0     0.0     0.0     0%    0.0     0.0   194.5     8.0     0.8     0%    0.1     0.6   0%      0
  7.0 md0              0.0     0.0     0.0     0%    0.0     0.0     0.0     0.0     0.0     0%    0.0     0.0   0%      0
EOF

group_by_all "samples/diskstats-001.txt" > $TMPDIR/got
no_diff $TMPDIR/got $TMPDIR/expected
